(defun c:roof-2chk-nn ( / *error* func wcs initvalueslst ucsf rlw unioncollinearplaneprints unique inside-p distp2t _vl-sort numbpos offd chkcircinside chkcircinside-dist collinear-pp searchipss process ti s dm lw lwi pl pli tl utl lst ll zz xxx x y ip ips ipss pos ang d t1 t2 tt tll q att lil lil1 lil2 )

  (defun *error* ( m )
    (foreach li lil
      (if (and (car li) (cadr li) (not (equal (car li) (cadr li) 1e-6)))
        (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li))))
      )
    )
    (if (and lwi (not (vlax-erased-p lwi)))
      (if (= (type lwi) (quote ename))
        (entdel lwi)
        (vla-delete lwi)
      )
    )
    (if wcs
      (if ucsf
        (while
          (not
            (and
              (equal (getvar (quote ucsxdir)) (car ucsf) 1e-6)
              (equal (getvar (quote ucsydir)) (cadr ucsf) 1e-6)
              (equal (trans (list 0.0 0.0 1.0) 1 0 t) (caddr ucsf) 1e-6)
            )
          )
          (exe (list "_.UCS" "_P"))
        )
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if initvalueslst
      (mapcar (function apply_cadr->car) initvalueslst)
    )
    (foreach fun (list (quote func) (quote vl-load) (quote exe) (quote cmdfun) (quote cmderr) (quote catch_cont) (quote apply_cadr->car) (quote ftoa))
      (setq fun nil)
    )
    (if doc
      (vla-regen doc acactiveviewport)
    )
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun func ( wcs / sysvarpreset sysvarlst sysvarvals ) ;;; wcs (T/nil) ;;; cad, doc, alo, spc - global variables (Visual Lisp main VLA-OBJECT pointers) ;;; vl-load exe cmdfun cmderr catch_cont apply_cadr->car ftoa - library sub functions common for standard template initialization ;;;

    (defun vl-load nil
      (or cad
        (if vlax-get-acad-object
          (setq cad (vlax-get-acad-object))
          (progn
            (vl-load-com)
            (setq cad (vlax-get-acad-object))
          )
        )
      )
      (or doc (setq doc (vla-get-activedocument cad)))
      (or alo (setq alo (vla-get-activelayout doc)))
      (or spc (setq spc (vla-get-block alo)))
    )

    ;;; sometimes not needed to use/initialize AxiveX Visual Lisp extensions - (comment/uncomment) following line ;;;
    (or (and cad doc alo spc) (vl-load))

    (defun exe ( tokenslist )
      ( (lambda ( tokenslist / ctch )
          (if (vl-catch-all-error-p (setq ctch (cmdfun tokenslist t)))
            (progn
              (cmderr tokenslist)
              (catch_cont ctch)
            )
            (progn
              (while (< 0 (getvar (quote cmdactive)))
                (vl-cmdf "")
              )
              t
            )
          )
        )
        tokenslist
      )
    )

    (defun cmdfun ( tokenslist flag / ctch ) ;;; tokenslist - command parameters list of strings ;;; flag - if "t" specified, upon successful execution returns t, otherwise if "nil" specified, return is always nil no matter what outcome of function execution is - it should be successful anyway if specified tokenslist was hardcoded correctly... ;;;
      (if command-s
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist)))
            ctch
          )
        )
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function vl-cmdf) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command) tokenslist)))
            ctch
          )
        )
      )
    )

    (defun cmderr ( tokenslist ) ;;; tokenslist - list of tokens representing command syntax at which used (cmdfun) failed with successful execution ;;;
      (prompt (strcat "\ncommand execution failure... error at used command tokenslist : " (vl-prin1-to-string tokenslist)))
    )

    (defun catch_cont ( ctch / gr )
      (prompt "\nleft mouse click to continue or enter to generate catch error - ESC to break...")
      (while
        (and
          (vl-catch-all-error-p (or ctch (setq ctch (vl-catch-all-apply (function /) (list 1 0)))))
          (setq gr (grread))
          (/= (car gr) 3)
          (not (equal gr (list 2 13)))
        )
      )
      (if (vl-catch-all-error-p ctch)
        ctch
      )
    )

    (defun apply_cadr->car ( sysvarvaluepair / ctch )
      (setq ctch (vl-catch-all-apply (function setvar) sysvarvaluepair))
      (if (vl-catch-all-error-p ctch)
        (progn
          (prompt (strcat "\ncatched error on setting system variable : " (vl-prin1-to-string (vl-symbol-name (car sysvarvaluepair))) " with value : " (vl-prin1-to-string (cadr sysvarvaluepair))))
          (catch_cont ctch)
        )
      )
    )

    (defun ftoa ( n / m a s b )
      (if (numberp n)
        (progn
          (setq m (fix ((if (< n 0) - +) n 1e-8)))
          (setq a (abs (- n m)))
          (setq m (itoa m))
          (setq s "")
          (while (and (not (equal a 0.0 1e-6)) (setq b (fix (* a 10.0))))
            (setq s (strcat s (itoa b)))
            (setq a (- (* a 10.0) b))
          )
          (if (= (type n) (quote int))
            m
            (if (= s "")
              m
              (if (and (= m "0") (< n 0))
                (strcat "-" m "." s)
                (strcat m "." s)
              )
            )
          )
        )
      )
    )

    (setq sysvarpreset
      (list
        (list (quote cmdecho) 0)
        (list (quote 3dosmode) 0)
        (list (quote osmode) 0)
        (list (quote unitmode) 0)
        (list (quote cmddia) 0)
        (list (quote ucsvp) 0)
        (list (quote ucsortho) 0)
        (list (quote projmode) 0)
        (list (quote orbitautotarget) 0)
        (list (quote insunits) 0)
        (list (quote hpseparate) 0)
        (list (quote hpgaptol) 0)
        (list (quote halogap) 0)
        (list (quote edgemode) 0)
        (list (quote pickdrag) 0)
        (list (quote qtextmode) 0)
        (list (quote dragsnap) 0)
        (list (quote angdir) 0)
        (list (quote aunits) 0)
        (list (quote limcheck) 0)
        (list (quote gridmode) 0)
        (list (quote nomutt) 0)
        (list (quote apbox) 0)
        (list (quote attdia) 0)
        (list (quote blipmode) 0)
        (list (quote copymode) 0)
        (list (quote circlerad) 0.0)
        (list (quote filletrad) 0.0)
        (list (quote filedia) 1)
        (list (quote autosnap) 1)
        (list (quote objectisolationmode) 1)
        (list (quote highlight) 1)
        (list (quote lispinit) 1)
        (list (quote layerpmode) 1)
        (list (quote fillmode) 1)
        (list (quote dragmodeinterrupt) 1)
        (list (quote dispsilh) 1)
        (list (quote fielddisplay) 1)
        (list (quote deletetool) 1)
        (list (quote delobj) 1)
        (list (quote dblclkedit) 1)
        (list (quote attreq) 1)
        (list (quote explmode) 1)
        (list (quote frameselection) 1)
        (list (quote ltgapselection) 1)
        (list (quote pickfirst) 1)
        (list (quote plinegen) 1)
        (list (quote plinetype) 1)
        (list (quote peditaccept) 1)
        (list (quote solidcheck) 1)
        (list (quote visretain) 1)
        (list (quote regenmode) 1)
        (list (quote celtscale) 1.0)
        (list (quote ltscale) 1.0)
        (list (quote osnapcoord) 2)
        (list (quote grips) 2)
        (list (quote dragmode) 2)
        (list (quote lunits) 2)
        (list (quote pickstyle) 3)
        (list (quote navvcubedisplay) 3)
        (list (quote pickauto) 3)
        (list (quote draworderctl) 3)
        (list (quote expert) 5)
        (list (quote auprec) 6)
        (list (quote luprec) 6)
        (list (quote pickbox) 6)
        (list (quote aperture) 6)
        (list (quote osoptions) 7)
        (list (quote dimzin) 8)
        (list (quote pdmode) 35)
        (list (quote pdsize) -1.5)
        (list (quote celweight) -1)
        (list (quote cecolor) "BYLAYER")
        (list (quote celtype) "ByLayer")
        (list (quote clayer) "0")
      )
    )
    (setq sysvarlst (mapcar (function car) sysvarpreset))
    (setq sysvarvals (mapcar (function cadr) sysvarpreset))
    (setq sysvarvals
      (vl-remove nil
        (mapcar
          (function (lambda ( x )
            (if (getvar x) (nth (vl-position x sysvarlst) sysvarvals))
          ))
          sysvarlst
        )
      )
    )
    (setq sysvarlst
      (vl-remove-if-not
        (function (lambda ( x )
          (getvar x)
        ))
        sysvarlst
      )
    )
    (setq initvalueslst
      (apply (function mapcar)
        (cons (function list)
          (list
            sysvarlst
            (mapcar (function getvar) sysvarlst)
          )
        )
      )
    )
    (apply (function mapcar)
      (cons (function setvar)
        (list
          sysvarlst
          sysvarvals
        )
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if (not (exe (list "_.UNDO" "_M")))
      (if doc
        (vla-startundomark doc)
      )
    )
    (if wcs
      (if (= 0 (getvar (quote worlducs)))
        (progn
          (setq ucsf
            (list
              (getvar (quote ucsxdir))
              (getvar (quote ucsydir))
              (trans (list 0.0 0.0 1.0) 1 0 t)
            )
          )
          (exe (list "_.UCS" "_W"))
        )
      )
    )
    wcs
  )

  (defun rlw ( lw / e x1 x2 x3 x4 x5 x6 )
    ;; by ElpanovEvgeniy
    (if (= (cdr (assoc 0 (setq e (entget lw)))) "LWPOLYLINE")
      (progn
        (foreach a1 e
          (cond
            ( (= (car a1) 10) (setq x2 (cons a1 x2)) )
            ( (= (car a1) 40) (setq x4 (cons (cons 41 (cdr a1)) x4)) )
            ( (= (car a1) 41) (setq x3 (cons (cons 40 (cdr a1)) x3)) )
            ( (= (car a1) 42) (setq x5 (cons (cons 42 (- (cdr a1))) x5)) )
            ( (= (car a1) 210) (setq x6 (cons a1 x6)) )
            ( t (setq x1 (cons a1 x1)) )
          )
        )
        (entmod
          (append (reverse x1)
            (append
              (apply (function append)
                (apply (function mapcar)
                  (cons (function list)
                    (list x2
                      (cdr (reverse (cons (car x3) (reverse x3))))
                      (cdr (reverse (cons (car x4) (reverse x4))))
                      (cdr (reverse (cons (car x5) (reverse x5))))
                    )
                  )
                )
              )
              x6
            )
          )
        )
        (entupd lw)
      )
    )
  )

  (defun unioncollinearplaneprints ( tl / a b tll )
    (while (setq a (car tl))
      (setq b (vl-remove-if-not (function (lambda ( x ) (and (collinear-pp (car a) (cadr a) (car x)) (collinear-pp (car a) (cadr a) (cadr x))))) tl))
      (setq tll (cons a tll))
      (if b
        (setq tl (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) b))) tl))
        (setq tl (cdr tl))
      )
    )
    tll
  )

  (defun unique ( lst / a ll )
    (while (setq a (car lst))
      (if (vl-some (function (lambda ( x ) (equal x a 1e-6))) (cdr lst))
        (setq ll (cons a ll) lst (vl-remove-if (function (lambda ( x ) (equal x a 1e-6))) (cdr lst)))
        (setq ll (cons a ll) lst (cdr lst))
      )
    )
    (reverse ll)
  )

  (defun inside-p ( p lw lwi )
    (< (distance p (vlax-curve-getclosestpointto lwi p)) (distance p (vlax-curve-getclosestpointto lw p)))
  )

  (defun distp2t ( p gg / i d )
    (if (setq i (inters p (polar p (+ (angle (car gg) (cadr gg)) (* 0.5 pi)) 1.0) (car gg) (cadr gg) nil))
      (setq d (distance p i))
    )
  )

  (defun _vl-sort ( lst func )
    (mapcar
      (function (lambda ( x ) (nth x lst)))
      (vl-sort-i lst func)
    )
  )

  (defun numbpos ( n len )
    (cond
      ( (< n len)
        n
      )
      ( (> n len)
        (- n len)
      )
      ( t 0 )
    )
  )

  (defun offd ( ip tl / ff d dl )

    (defun ff ( ip d )
      (if (not (chkcircinside-dist ip d))
        (progn
          (setq dl (vl-remove-if (function (lambda ( x ) (equal d x 1e-6))) dl))
          (ff ip
            (setq d
              (vl-some
                (function
                  (lambda ( x )
                    (if
                      (>
                        (-
                          (length dl)
                          (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-5))) dl))
                        ) 2
                      )
                      x
                    )
                  )
                )
                (_vl-sort dl (function >))
              )
            )
          )
        )
        d
      )
    )

    (setq dl
      (mapcar
        (function
          (lambda ( x )
            (distance ip
              (inters
                ip
                (polar ip (+ (* 0.5 pi) (angle (car x) (cadr x))) 1.0)
                (car x)
                (polar (car x) (angle (car x) (cadr x)) 1.0)
                nil
              )
            )
          )
        )
        tl
      )
    )
    (setq d
      (vl-some
        (function
          (lambda ( x )
            (if
              (>
                (-
                  (length dl)
                  (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-5))) dl))
                ) 2
              )
              x
            )
          )
        )
        (_vl-sort dl (function >))
      )
    )
    (ff ip d)
  )

  (defun chkcircinside-dist ( pp dist / ci ipp ippl params pts tst )
    (if (and pp dist)
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 dist))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) (quote intersectwith) (vlax-ename->vla-object lw) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (setq params (mapcar (function (lambda ( x ) (vlax-curve-getparamatpoint ci x))) ippl))
            (setq pts (apply (function append) (mapcar (function (lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.33)) (vlax-curve-getpointatparam ci (+ x 0.33))))) params)))
            (if (or (not ippl) (vl-every (function (lambda ( x ) (inside-p x lw lwi))) pts))
              (setq tst (cons t tst))
              (setq tst (cons nil tst))
            )
          )
          (setq tst (cons t tst))
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    (apply (function and) tst)
  )

  (defun chkcircinside ( pp tll / dd ci ipp ippl params pts tst )
    (if (and pp tll)
      (if (setq dd (offd pp tll))
        (progn
          (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 dd))))
          (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) (quote intersectwith) (vlax-ename->vla-object lw) acextendnone))
            (progn
              (while ipp
                (setq ippl (cons (list (car ipp) (cadr ipp)) ippl))
                (setq ipp (cdddr ipp))
              )
              (setq params (mapcar (function (lambda ( x ) (vlax-curve-getparamatpoint ci x))) ippl))
              (setq pts (apply (function append) (mapcar (function (lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.33)) (vlax-curve-getpointatparam ci (+ x 0.33))))) params)))
              (if (or (not ippl) (vl-every (function (lambda ( x ) (inside-p x lw lwi))) pts))
                (setq tst (cons t tst))
                (setq tst (cons nil tst))
              )
            )
            (setq tst (cons t tst))
          )
          (if (and ci (not (vlax-erased-p ci)))
            (entdel ci)
          )
        )
      )
    )
    (if tst
      (apply (function and) tst)
    )
  )

  (defun collinear-pp ( p1 p2 p3 )
    ( (lambda ( a b c )
        (or
          (equal (+ a b) c 1e-8)
          (equal (+ b c) a 1e-8)
          (equal (+ c a) b 1e-8)
        )
      )
      (distance p1 p2) (distance p2 p3) (distance p1 p3)
    )
  )

  (defun searchipss nil
    (setq ll lst ipss nil)
    (setq x (car ll) dm 1e+308)
    (setq ll (vl-remove-if (function (lambda ( z ) (equal z x 1e-3))) ll))
    (while (setq y (car ll))
      (setq ll (cdr ll))
      (if (and x y (setq ip (inters (car x) (polar (car x) (cadr x) 1.0) (car y) (polar (car y) (cadr y) 1.0) nil)))
        (if (not (equal (setq d (distance ip (caar lil))) 0.0 1e-3))
          (if (and d (< d dm) (chkcircinside ip utl))
            (setq ipss (list ip x y) dm d)
          )
        )
      )
    )
    ipss
  )

  (defun process ( lst att / done lil flag k )
    (while (not done)
      (if (not flag)
        (progn
          (setq ll lst ips nil dm 1e+308)
          (while (setq x (car ll))
            (setq ll (cdr ll))
            (setq y (car ll))
            (if (and x y (setq ip (inters (car x) (polar (car x) (cadr x) 1.0) (car y) (polar (car y) (cadr y) 1.0) nil)) (inside-p ip lw lwi))
              (if (< (setq d (min (distp2t ip (caddr x)) (distp2t ip (last y)))) dm)
                (setq ips (list ip x y) dm d)
              )
            )
          )
          (setq pos (vl-position (cadr ips) lst))
          (if pos
            (repeat (numbpos pos (length pl))
              (setq lst (append (cdr lst) (list (car lst))))
              (setq tl (append (cdr tl) (list (car tl))))
              (setq pl (append (cdr pl) (list (car pl))))
              (setq pli (append (cdr pli) (list (car pli))))
            )
          )
          (setq tt (vl-remove-if (function (lambda ( x ) (= (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-6))) (list (caddr (cadr ips)) (cadddr (cadr ips)) (caddr (caddr ips)) (cadddr (caddr ips))))) 2))) (list (caddr (cadr ips)) (cadddr (cadr ips)) (caddr (caddr ips)) (cadddr (caddr ips)))))
          (setq zz (car (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) tt))) (list (caddr (cadr ips)) (cadddr (cadr ips)) (caddr (caddr ips)) (cadddr (caddr ips))))))
          (setq tl (vl-remove zz tl))
          (if (and (car ips) (car (cadr ips)) (car (caddr ips)))
            (cond
              ( (= att 1)
                (setq lil (cons (list (car ips) (car (caddr ips))) lil))
                (setq lil (cons (list (car ips) (car (cadr ips))) lil))
              )
              ( (= att 2)
                (setq lil (cons (list (car ips) (car (cadr ips))) lil))
                (setq lil (cons (list (car ips) (car (caddr ips))) lil))
              )
            )
          )
          (setq ang (angle (car ips) (inters (caar tt) (cadar tt) (caadr tt) (cadadr tt) nil)))
          (setq lst (cons (setq ips (list (car ips) ang (car tt) (cadr tt))) lst))
        )
      )
      (setq flag t)
      (setq ipss (searchipss))
      (if ipss
        (progn
          (setq t1 (car tl))
          (setq t2 (last tl))
          (setq tll tl)
          (if (setq xxx (vl-some (function (lambda ( x ) (vl-some (function (lambda ( y ) (if (equal x y 1e-6) x))) (cddr (car lst))))) (cddr (cadr lst))))
            (progn
              (setq tl (vl-remove xxx tl))
              (setq t1 (car tl))
              (setq t2 (last tl))
              (if (and tl (> (length tl) 1))
                (progn
                  (setq ang (angle (car ipss) (inters (car t1) (cadr t1) (car t2) (cadr t2) nil)))
                  (setq ips (list (car ipss) ang t1 t2))
                  (if (not (equal ang (cadar lst) 1e-6))
                    (progn
                      (setq lst (cons ips lst))
                      (setq lil (cons (list (car ips) (caar lil)) lil))
                      (foreach p pl
                        (if (equal (angle p (car ips)) (cadr (assoc p lst)) 1e-6)
                          (setq lil (cons (list (car ips) p) lil))
                        )
                      )
                    )
                  )
                )
              )
              (if (not (searchipss))
                (if (setq ipss (searchipss))
                  (progn
                    (setq lst (cdr lst))
                    (setq xxx (car (vl-remove xxx (cddr (car lst)))))
                    (setq tl tll)
                    (setq tl (vl-remove xxx tl))
                    (setq lst (cdr lst))
                    (setq lil (cddr lil))
                    (setq t1 (car tl))
                    (setq t2 (last tl))
                    (if (and tl (> (length tl) 1))
                      (progn
                        (setq ang (angle (car ipss) (inters (car t1) (cadr t1) (car t2) (cadr t2) nil)))
                        (setq ips (list (car ipss) ang t1 t2))
                        (if (not (equal ang (cadar lst) 1e-6))
                          (progn
                            (setq lst (cons ips lst))
                            (setq lil (cons (list (car ips) (caar lil)) lil))
                            (foreach p pl
                              (if (equal (angle p (car ips)) (cadr (assoc p lst)) 1e-6)
                                (setq lil (cons (list (car ips) p) lil))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
      (if (not k)
        (setq k 1)
        (setq k (1+ k))
      )
      (if
        (or
          (equal k (length pl))
          (vl-every (function (lambda ( x ) (vl-position x (mapcar (function cadr) lil)))) pl)
        )
        (setq done t)
      )
    )
    (unique lil)
  )

  (setq wcs (func t)) ;;; starting "library" template sub function - initialization ;;;
  (prompt "\nPick closed polygonal LWPOLYLINE on unlocked layer...")
  (if (setq s (ssget "_+.:E:S:L" (list (cons 0 "LWPOLYLINE") (cons -4 "&=") (cons 70 1) (cons -4 "<not") (cons -4 "<>") (cons 42 0.0) (cons -4 "not>"))))
    (progn
      (setq ti (car (_vl-times)))
      (setq dm 1e+308)
      (setq lw (ssname s 0))
      (vlax-invoke (vlax-ename->vla-object lw) (quote offset) -1e-3)
      (setq lwi (entlast))
      (if (> (vlax-curve-getarea lwi) (vlax-curve-getarea lw))
        (progn
          (rlw lw)
          (entdel lwi)
          (vlax-invoke (vlax-ename->vla-object lw) (quote offset) -1e-3)
          (setq lwi (entlast))
        )
      )
      (while (< att 2)
        (if (not att)
          (setq att 1)
          (setq att (1+ att))
        )
        (setq pl (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) (entget lw))))
        (setq pli (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) (entget lwi))))
        (while (not (equal (car pl) (car pli) 0.1))
          (setq pli (append (cdr pli) (list (car pli))))
        )
        (setq tl (mapcar (function (lambda ( a b ) (list a b))) pl (append (cdr pl) (list (car pl)))))
        (setq utl (unioncollinearplaneprints tl))
        (setq lst (mapcar (function (lambda ( a b c d ) (list a (angle a b) c d))) pl pli (cons (last tl) (reverse (cdr (reverse tl)))) tl))
        (setq lil nil)
        (setq lil (process lst att))
        (cond
          ( (= att 1)
            (setq lil1 lil)
          )
          ( (= att 2)
            (setq lil2 lil)
          )
        )
      )
      (if (> (length lil1) (length lil2))
        (setq lil lil1)
        (setq lil lil2)
      )
      (prompt "\nElapsed time : ") (prompt (ftoa (- (car (_vl-times)) ti))) (prompt " milliseconds...")
      (prompt "\nFor UNDO - type \"UNDO\" - \"Back\" option...")
    )
  )
  (*error* nil)
)
