(defun c:roof-nn ( / *error* lilchk _offset groupbynum unit rlw unioncollinearplaneprints offd inside-p collinear-p collinear-pp unique chkcircinside chkcircinside-dist mc subbody subprocess preprocess prout process osm cmd m n kj s lw lwi lwx ent enti lil lix el p1 p2 pp ppp ipp ippl vll vlli tll iplst vl vli tl lst ti ) ;;; cad, doc, spc, lay, vlll, vllli, tlll, f - global variables ;;;

  (defun *error* ( m )
    (if (and lwi (not (vlax-erased-p lwi)))
      (entdel lwi)
    )
    (if (and enti (not (vlax-erased-p enti)))
      (entdel enti)
    )
    (if el
      (while (setq el (entnext el))
        (if (and el (not (vlax-erased-p el)))
          (entdel el)
        )
      )
    )
    (if lil
      (progn
        (lilchk)
        (foreach li lil
          (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li)) (cons 62 3)))
        )
      )
    )
    (if (and lil (setq ppp (unique (mapcar 'car lil))))
      (foreach pp ppp
        (entmake (list (cons 0 "POINT") (cons 10 pp) (cons 62 1)))
      )
    )
    ;;;(command-s "_.-OVERKILL" "_ALL" "_T" "_Y" "" "")
    (if osm
      (setvar 'osmode osm)
    )
    (if cmd
      (setvar 'cmdecho cmd)
    )
    (if (= 8 (logand 8 (getvar 'undoctl)))
      (vla-endundomark doc)
    )
    (prompt "\nIf you want to start again on different sample, make sure you nil flag f : (setq f nil vlll nil vllli nil tlll nil lil nil ppp nil lst nil) ...")
    (setq f nil vlll nil vllli nil tlll nil lil nil ppp nil lst nil) ;;; global variables nilled through error handler...
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun lilchk ( / lll ip )
    (setq lll lil)
    (foreach l1 lll
      (setq lll (vl-remove l1 lll))
      (foreach l2 lll
        (if (and (not (equal (car l1) (car l2) 1e-6)) (setq ip (inters (car l1) (cadr l1) (car l2) (cadr l2))) (not (equal (car l1) ip 1e-6)) (not (equal (car l2) ip 1e-6)) (not (equal (cadr l1) ip 1e-6)) (not (equal (cadr l2) ip 1e-6)))
          (setq lil (subst (list ip (cadr l1)) l1 lil) lil (subst (list ip (cadr l2)) l2 lil))
        )
      )
    )
  )

  (defun _offset ( lw dist / lill lww vl lwx tl tln iplst )
    (setq vl (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (setq lwx (entget lw)))))
    (setq tl (mapcar '(lambda ( a b ) (list a b)) vl (append (cdr vl) (list (car vl)))))
    (setq tln (mapcar '(lambda ( x ) (list (polar (car x) (+ (* 0.5 pi) (angle (car x) (cadr x))) (- dist)) (polar (cadr x) (+ (* 0.5 pi) (angle (car x) (cadr x))) (- dist)))) tl))
    (setq iplst (mapcar '(lambda ( a b ) (inters (car a) (cadr a) (car b) (cadr b) nil)) tln (append (cdr tln) (list (car tln)))))
    (setq lill (mapcar '(lambda ( a b ) (list a b)) iplst (append (cdr iplst) (list (car iplst)))))
    (setq lill (vl-remove-if '(lambda ( x ) (or (null (car x)) (null (cadr x)))) lill))
    (list
      (entmakex
        (append
          (list
            (cons 0 "LWPOLYLINE")
            (cons 100 "AcDbEntity")
            (cons 100 "AcDbPolyline")
            (cons 90 (length iplst))
            (cons 70 (1+ (* 128 (getvar 'plinegen))))
            (cons 38 0.0)
          )
          (mapcar '(lambda ( p ) (cons 10 p)) iplst)
          (list (list 210 0.0 0.0 1.0))
        )
      )
    )
  )

  (defun groupbynum ( lst n / sub lll )

    (defun sub ( m n / ll q )
      (cond
        ( (and m (< (length m) n))
          (repeat (- n (length m))
            (setq m (append m (list nil)))
          )
          (setq ll (vl-remove-if-not (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m))
          (setq lll (cons ll lll))
          (setq q nil)
          (sub (vl-remove-if (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m) n)
        )
        ( m
          (setq ll (vl-remove-if-not (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m))
          (setq lll (cons ll lll))
          (setq q nil)
          (sub (vl-remove-if (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m) n)
        )
        ( t
          (reverse lll)
        )
      )
    )

    (sub lst n)
  )

  (defun unit ( v / d )
    (if (not (equal (setq d (distance '(0.0 0.0 0.0) v)) 0.0 1e-6))
      (mapcar '(lambda ( x ) (/ x d)) v)
    )
  )

  (defun rlw ( lw / e x1 x2 x3 x4 x5 x6 )
    ;; by ElpanovEvgeniy
    (if (= (cdr (assoc 0 (setq e (entget lw)))) "LWPOLYLINE")
      (progn
        (foreach a1 e
          (cond
            ( (= (car a1) 10) (setq x2 (cons a1 x2)) )
            ( (= (car a1) 40) (setq x4 (cons (cons 41 (cdr a1)) x4)) )
            ( (= (car a1) 41) (setq x3 (cons (cons 40 (cdr a1)) x3)) )
            ( (= (car a1) 42) (setq x5 (cons (cons 42 (- (cdr a1))) x5)) )
            ( (= (car a1) 210) (setq x6 (cons a1 x6)) )
            ( t (setq x1 (cons a1 x1)) )
          )
        )
        (entmod
          (append (reverse x1)
            (append
              (apply 'append
                (apply 'mapcar
                  (cons 'list
                    (list x2
                      (cdr (reverse (cons (car x3) (reverse x3))))
                      (cdr (reverse (cons (car x4) (reverse x4))))
                      (cdr (reverse (cons (car x5) (reverse x5))))
                    )
                  )
                )
              )
              x6
            )
          )
        )
        (entupd lw)
      )
    )
  )

  (defun unioncollinearplaneprints ( tl / a b tll )
    (while (setq a (car tl))
      (setq b (vl-remove-if-not (function (lambda ( x ) (and (collinear-pp (car a) (cadr a) (car x)) (collinear-pp (car a) (cadr a) (cadr x))))) tl))
      (setq tll (cons a tll))
      (if b
        (setq tl (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) b))) tl))
        (setq tl (cdr tl))
      )
    )
    tll
  )

  (defun offd ( ip tl / f d dl )

    (defun f ( ip d )
      (if (not (chkcircinside-dist ip d))
        (progn
          (setq dl (vl-remove-if '(lambda ( x ) (equal d x 1e-6)) dl))
          (f ip
            (setq d
              (vl-some
               '(lambda ( x )
                  (if
                    (>
                      (-
                        (length dl)
                        (length (vl-remove-if '(lambda ( y ) (equal x y 1e-5)) dl))
                      ) 2
                    )
                    x
                  )
                ) (vl-sort dl (function >))
              )
            )
          )
        )
        d
      )
    )

    (setq dl
      (mapcar
       '(lambda ( x )
          (distance ip
            (inters
              ip
              (polar ip (+ (* 0.5 pi) (angle (car x) (cadr x))) 1.0)
              (car x)
              (polar (car x) (angle (car x) (cadr x)) 1.0)
              nil
            )
          )
        ) tl
      )
    )
    (setq d
      (vl-some 
       '(lambda ( x )
          (if
            (>
              (-
                (length dl)
                (length (vl-remove-if '(lambda ( y ) (equal x y 1e-5)) dl))
              ) 2
            )
            x
          )
        ) (vl-sort dl (function >))
      )
    )
    (f ip d)
  )

  (defun inside-p ( p lw lwi )
    (< (distance p (vlax-curve-getclosestpointto lwi p)) (distance p (vlax-curve-getclosestpointto lw p)))
  )

  (defun collinear-p ( p1 p p2 )
    (equal (distance p1 p2) (+ (distance p1 p) (distance p p2)) 1e-8)
  )

  (defun collinear-pp ( p1 p2 p3 )
    ( (lambda ( a b c )
        (or
          (equal (+ a b) c 1e-8)
          (equal (+ b c) a 1e-8)
          (equal (+ c a) b 1e-8)
        )
      )
      (distance p1 p2) (distance p2 p3) (distance p1 p3)
    )
  )

  (defun unique ( lst )
    (if lst
      (cons (car lst)
        (unique
          (vl-remove-if
           '(lambda ( x )
              (equal x (car lst) 1e-3)
            )
            (cdr lst)
          )
        )
      )
    )
  )

  (defun chkcircinside ( pp tll / ci ipp ippl params pts tst )
    (if (and pp tll)
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 (offd pp tll)))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object ent) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (setq params (mapcar '(lambda ( x ) (vlax-curve-getparamatpoint ci x)) ippl))
            (setq pts (apply 'append (mapcar '(lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.33)) (vlax-curve-getpointatparam ci (+ x 0.33)))) params)))
            (if (or (not ippl) (vl-every '(lambda ( x ) (inside-p x ent enti)) pts))
              (setq tst (cons t tst))
              (setq tst (cons nil tst))
            )
          )
          (setq tst (cons t tst))
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    (apply 'and tst)
  )

  (defun chkcircinside-dist ( pp dist / ci ipp ippl params pts tst )
    (if (and pp dist)
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 dist))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object ent) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (setq params (mapcar '(lambda ( x ) (vlax-curve-getparamatpoint ci x)) ippl))
            (setq pts (apply 'append (mapcar '(lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.33)) (vlax-curve-getpointatparam ci (+ x 0.33)))) params)))
            (if (or (not ippl) (vl-every '(lambda ( x ) (inside-p x ent enti)) pts))
              (setq tst (cons t tst))
              (setq tst (cons nil tst))
            )
          )
          (setq tst (cons t tst))
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    (apply 'and tst)
  )

  (defun mc ( p lw lww lwww / mid ci pl pll1 pll2 plll pllll mp p1 p2 p3 p4 p121 p231 p341 p141 p131 p241 p122 p232 p342 p142 p132 p242 pp1 pp2 pp3 pp4 ppp1 ppp2 ppp3 ppp4 )

    (defun mid ( ci p1 p2 / par1 par2 mp )
      (setq par1 (+ (* 2 pi) (vlax-curve-getparamatpoint ci p1)) par2 (+ (* 2 pi) (vlax-curve-getparamatpoint ci p2)))
      (setq mp (mapcar '+ '(0.0 0.0) (vlax-curve-getpointatparam ci (/ (+ par1 par2) 2.0))))
    )

    (if (and (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 p) (cons 40 0.5)))) lw (not (vlax-erased-p ci)) (not (vlax-erased-p lw)))
      (setq pl (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object lw) acextendnone))
    )
    (setq pll1 (vlax-invoke (vlax-ename->vla-object lww) 'intersectwith (vlax-ename->vla-object lww) acextendnone))
    (setq pll1 (groupbynum pll1 3))
    (setq pll1 (mapcar '(lambda ( x ) (list (car x) (cadr x))) pll1))
    (setq pll2 (vlax-invoke (vlax-ename->vla-object lwww) 'intersectwith (vlax-ename->vla-object lwww) acextendnone))
    (setq pll2 (groupbynum pll2 3))
    (setq pll2 (mapcar '(lambda ( x ) (list (car x) (cadr x))) pll2))
    (setq plll (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object lww) acextendnone))
    (setq plll (groupbynum plll 3))
    (setq plll (mapcar '(lambda ( x ) (list (car x) (cadr x))) plll))
    (setq pllll (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object lwww) acextendnone))
    (setq pllll (groupbynum pllll 3))
    (setq pllll (mapcar '(lambda ( x ) (list (car x) (cadr x))) pllll))
    (if pl
      (cond
        ( (= (length pl) 12)
          (setq p1 (list (car pl) (cadr pl)))
          (setq p2 (list (nth 3 pl) (nth 4 pl)))
          (setq p3 (list (nth 6 pl) (nth 7 pl)))
          (setq p4 (list (nth 9 pl) (nth 10 pl)))
          (mapcar 'set '(p1 p2 p3 p4) (vl-sort (list p1 p2 p3 p4) '(lambda ( a b ) (< (vlax-curve-getparamatpoint ci a) (vlax-curve-getparamatpoint ci b)))))
          (if (equal (vlax-curve-getparamatpoint ci p4) (* 2 pi) 1e-6)
            (mapcar 'set '(p1 p2 p3 p4) (list p4 p1 p2 p3))
          )
          (setq p121 (mid ci p1 p2))
          (setq p231 (mid ci p2 p3))
          (setq p341 (mid ci p3 p4))
          (setq p141 (mid ci p1 p4))
          (setq p131 (mid ci p1 p3))
          (setq p241 (mid ci p2 p4))
          (setq p122 (polar p (angle p121 p) 0.5))
          (setq p232 (polar p (angle p231 p) 0.5))
          (setq p342 (polar p (angle p341 p) 0.5))
          (setq p142 (polar p (angle p141 p) 0.5))
          (setq p132 (polar p (angle p131 p) 0.5))
          (setq p242 (polar p (angle p241 p) 0.5))
          (setq pp1 (vl-remove-if-not '(lambda ( x ) (equal x p1 0.1)) plll))
          (setq pp2 (vl-remove-if-not '(lambda ( x ) (equal x p2 0.1)) plll))
          (setq pp3 (vl-remove-if-not '(lambda ( x ) (equal x p3 0.1)) plll))
          (setq pp4 (vl-remove-if-not '(lambda ( x ) (equal x p4 0.1)) plll))
          (setq ppp1 (vl-remove-if-not '(lambda ( x ) (equal x p1 0.1)) pllll))
          (setq ppp2 (vl-remove-if-not '(lambda ( x ) (equal x p2 0.1)) pllll))
          (setq ppp3 (vl-remove-if-not '(lambda ( x ) (equal x p3 0.1)) pllll))
          (setq ppp4 (vl-remove-if-not '(lambda ( x ) (equal x p4 0.1)) pllll))
          (cond
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p121)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p121)) pll2)) (not (collinear-pp p121 p (cadar lil))) (not (collinear-pp p121 p (cadadr lil))) (not (equal (distance p1 p2) 1.0 1e-6)))
              (setq mp p121)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p122)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p122)) pll2)) (not (collinear-pp p122 p (cadar lil))) (not (collinear-pp p122 p (cadadr lil))) (not (equal (distance p1 p2) 1.0 1e-6)))
              (setq mp p122)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p231)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p231)) pll2)) (not (collinear-pp p231 p (cadar lil))) (not (collinear-pp p231 p (cadadr lil))) (not (equal (distance p2 p3) 1.0 1e-6)))
              (setq mp p231)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p232)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p232)) pll2)) (not (collinear-pp p232 p (cadar lil))) (not (collinear-pp p232 p (cadadr lil))) (not (equal (distance p2 p3) 1.0 1e-6)))
              (setq mp p232)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p341)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p341)) pll2)) (not (collinear-pp p341 p (cadar lil))) (not (collinear-pp p341 p (cadadr lil))) (not (equal (distance p3 p4) 1.0 1e-6)))
              (setq mp p341)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p342)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p342)) pll2)) (not (collinear-pp p342 p (cadar lil))) (not (collinear-pp p342 p (cadadr lil))) (not (equal (distance p3 p4) 1.0 1e-6)))
              (setq mp p342)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p141)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p141)) pll2)) (not (collinear-pp p141 p (cadar lil))) (not (collinear-pp p141 p (cadadr lil))) (not (equal (distance p1 p4) 1.0 1e-6)))
              (setq mp p141)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p142)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p142)) pll2)) (not (collinear-pp p142 p (cadar lil))) (not (collinear-pp p142 p (cadadr lil))) (not (equal (distance p1 p4) 1.0 1e-6)))
              (setq mp p142)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p131)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p131)) pll2)) (not (collinear-pp p131 p (cadar lil))) (not (collinear-pp p131 p (cadadr lil))) (not (equal (distance p1 p3) 1.0 1e-6)))
              (setq mp p131)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p132)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p132)) pll2)) (not (collinear-pp p132 p (cadar lil))) (not (collinear-pp p132 p (cadadr lil))) (not (equal (distance p1 p3) 1.0 1e-6)))
              (setq mp p132)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p241)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p241)) pll2)) (not (collinear-pp p241 p (cadar lil))) (not (collinear-pp p241 p (cadadr lil))) (not (equal (distance p2 p4) 1.0 1e-6)))
              (setq mp p241)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p242)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p242)) pll2)) (not (collinear-pp p242 p (cadar lil))) (not (collinear-pp p242 p (cadadr lil))) (not (equal (distance p2 p4) 1.0 1e-6)))
              (setq mp p242)
            )
            ( (and (= (length pp1) 2) (not (collinear-pp p1 p (cadar lil))) (not (collinear-pp p1 p (cadadr lil))))
              (setq mp p1)
            )
            ( (and (= (length pp2) 2) (not (collinear-pp p2 p (cadar lil))) (not (collinear-pp p2 p (cadadr lil))))
              (setq mp p2)
            )
            ( (and (= (length pp3) 2) (not (collinear-pp p3 p (cadar lil))) (not (collinear-pp p3 p (cadadr lil))))
              (setq mp p3)
            )
            ( (and (= (length pp4) 2) (not (collinear-pp p4 p (cadar lil))) (not (collinear-pp p4 p (cadadr lil))))
              (setq mp p4)
            )
            ( (and (= (length pp1) 1) (= (length ppp1) 1) (not (collinear-pp p1 p (cadar lil))) (not (collinear-pp p1 p (cadadr lil))))
              (setq mp p1)
            )
            ( (and (= (length pp2) 1) (= (length ppp2) 1) (not (collinear-pp p2 p (cadar lil))) (not (collinear-pp p2 p (cadadr lil))))
              (setq mp p2)
            )
            ( (and (= (length pp3) 1) (= (length ppp3) 1) (not (collinear-pp p3 p (cadar lil))) (not (collinear-pp p3 p (cadadr lil))))
              (setq mp p3)
            )
            ( (and (= (length pp4) 1) (= (length ppp4) 1) (not (collinear-pp p4 p (cadar lil))) (not (collinear-pp p4 p (cadadr lil))))
              (setq mp p4)
            )
          )
        )
        ( (= (length pl) 9)
          (setq p1 (list (car pl) (cadr pl)))
          (setq p2 (list (nth 3 pl) (nth 4 pl)))
          (setq p3 (list (nth 6 pl) (nth 7 pl)))
          (mapcar 'set '(p1 p2 p3) (vl-sort (list p1 p2 p3) '(lambda ( a b ) (< (vlax-curve-getparamatpoint ci a) (vlax-curve-getparamatpoint ci b)))))
          (if (equal (vlax-curve-getparamatpoint ci p3) (* 2 pi) 1e-6)
            (mapcar 'set '(p1 p2 p3) (list p3 p1 p2))
          )
          (setq p121 (mid ci p1 p2))
          (setq p231 (mid ci p2 p3))
          (setq p131 (mid ci p1 p3))
          (setq p122 (polar p (angle p121 p) 0.5))
          (setq p232 (polar p (angle p231 p) 0.5))
          (setq p132 (polar p (angle p131 p) 0.5))
          (setq pp1 (vl-remove-if-not '(lambda ( x ) (equal x p1 0.1)) plll))
          (setq pp2 (vl-remove-if-not '(lambda ( x ) (equal x p2 0.1)) plll))
          (setq pp3 (vl-remove-if-not '(lambda ( x ) (equal x p3 0.1)) plll))
          (setq ppp1 (vl-remove-if-not '(lambda ( x ) (equal x p1 0.1)) pllll))
          (setq ppp2 (vl-remove-if-not '(lambda ( x ) (equal x p2 0.1)) pllll))
          (setq ppp3 (vl-remove-if-not '(lambda ( x ) (equal x p3 0.1)) pllll))
          (cond
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p121)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p121)) pll2)) (not (collinear-pp p121 p (cadar lil))) (not (collinear-pp p121 p (cadadr lil))) (not (equal (distance p1 p2) 1.0 1e-6)))
              (setq mp p121)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p122)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p122)) pll2)) (not (collinear-pp p122 p (cadar lil))) (not (collinear-pp p122 p (cadadr lil))) (not (equal (distance p1 p2) 1.0 1e-6)))
              (setq mp p122)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p131)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p131)) pll2)) (not (collinear-pp p131 p (cadar lil))) (not (collinear-pp p131 p (cadadr lil))) (not (equal (distance p1 p3) 1.0 1e-6)))
              (setq mp p131)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p132)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p132)) pll2)) (not (collinear-pp p132 p (cadar lil))) (not (collinear-pp p132 p (cadadr lil))) (not (equal (distance p1 p3) 1.0 1e-6)))
              (setq mp p132)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p231)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p231)) pll2)) (not (collinear-pp p231 p (cadar lil))) (not (collinear-pp p231 p (cadadr lil))) (not (equal (distance p2 p3) 1.0 1e-6)))
              (setq mp p231)
            )
            ( (and (or (vl-some '(lambda ( x ) (collinear-p p x p232)) pll1) (vl-some '(lambda ( x ) (collinear-p p x p232)) pll2)) (not (collinear-pp p232 p (cadar lil))) (not (collinear-pp p232 p (cadadr lil))) (not (equal (distance p2 p3) 1.0 1e-6)))
              (setq mp p232)
            )
            ( (and (= (length pp1) 2) (not (collinear-pp p1 p (cadar lil))) (not (collinear-pp p1 p (cadadr lil))))
              (setq mp p1)
            )
            ( (and (= (length pp2) 2) (not (collinear-pp p2 p (cadar lil))) (not (collinear-pp p2 p (cadadr lil))))
              (setq mp p2)
            )
            ( (and (= (length pp3) 2) (not (collinear-pp p3 p (cadar lil))) (not (collinear-pp p3 p (cadadr lil))))
              (setq mp p3)
            )
            ( (and (= (length pp1) 1) (= (length ppp1) 1) (not (collinear-pp p1 p (cadar lil))) (not (collinear-pp p1 p (cadadr lil))))
              (setq mp p1)
            )
            ( (and (= (length pp2) 1) (= (length ppp2) 1) (not (collinear-pp p2 p (cadar lil))) (not (collinear-pp p2 p (cadadr lil))))
              (setq mp p2)
            )
            ( (and (= (length pp3) 1) (= (length ppp3) 1) (not (collinear-pp p3 p (cadar lil))) (not (collinear-pp p3 p (cadadr lil))))
              (setq mp p3)
            )
          )
        )
        ( (= (length pl) 6)
          (setq p1 (list (car pl) (cadr pl)))
          (setq p2 (list (nth 3 pl) (nth 4 pl)))
          (setq p12 (mid ci p1 p2))
          (if (and (equal p1 p2 1e-6) (not (collinear-pp p1 p (cadar lil))) (not (collinear-pp p1 p (cadadr lil))))
            (setq mp p1)
          )
          (if (not mp)
            (setq mp p12)
          )
        )
        ( (= (length pl) 3)
          (setq mp (list (car pl) (cadr pl)))
        )
      )
    )
    (if (and ci (not (vlax-erased-p ci)))
      (entdel ci)
    )
    (list p mp)
  )

  (defun subbody ( ipd / n p1 p2 pp1 pp2 ttt d1 d2 fl r pre suf r m o lwnl lwwnl lwwwnl ddl ddm )
    (if (and (car ipd) (cadr ipd) (caddr ipd) (chkcircinside (car ipd) tlll))
      (progn
        (if lil
          (setq n (length lil))
          (setq n 0)
        )
        (if
          (and
            (setq p1
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) (caadr ipd)))
                    1e-6
                  )
                  x
                )
              ) vll
              )
            )
            (setq pp1
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) p1))
                    1e-6
                  )
                  x
                )
              ) vlll
              )
            )
          )
          (if (not (vl-position (list (car ipd) pp1) lil))
            (setq lil (cons (list (car ipd) pp1) lil))
          )
          (if p1
            (if (not (vl-position (list (car ipd) p1) lil))
              (setq lil (cons (list (car ipd) p1) lil))
            )
            (if (not (vl-position (list (car ipd) (caadr ipd)) lil))
              (setq lil (cons (list (car ipd) (caadr ipd)) lil))
            )
          )
        )
        (if (setq ttt (vl-remove nil (mapcar '(lambda ( x ) (if (or (equal (cadar lil) (car x) 1e-6) (equal (cadar lil) (cadr x) 1e-6)) x)) tlll)))
          (progn
            (setq d1 (distance (caar lil) (inters (caar lil) (polar (caar lil) (+ (* 0.5 pi) (angle (caar ttt) (cadar ttt))) 1.0) (caar ttt) (cadar ttt) nil)))
            (setq d2 (distance (caar lil) (inters (caar lil) (polar (caar lil) (+ (* 0.5 pi) (angle (caadr ttt) (cadadr ttt))) 1.0) (caadr ttt) (cadadr ttt) nil)))
            (if
              (and
                (not (chkcircinside-dist (caar lil) d1))
                (not (chkcircinside-dist (caar lil) d2))
              )
              (setq lil (cdr lil) fl t)
            )
          )
        )
        (if
          (and
            (setq p2
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) (cadadr ipd)))
                    1e-6
                  )
                  x
                )
              ) vll
              )
            )
            (setq pp2
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) p2))
                    1e-6
                  )
                  x
                )
              ) vlll
              )
            )
          )
          (if (not (vl-position (list (car ipd) pp2) lil))
            (setq lil (cons (list (car ipd) pp2) lil))
          )
          (if p2
            (if (not (vl-position (list (car ipd) p2) lil))
              (setq lil (cons (list (car ipd) p2) lil))
            )
            (if (not (vl-position (list (car ipd) (cadadr ipd)) lil))
              (setq lil (cons (list (car ipd) (cadadr ipd)) lil))
            )
          )
        )
        (if fl
          (setq lil (cdr lil))
          (if (setq ttt (vl-remove nil (mapcar '(lambda ( x ) (if (or (equal (cadar lil) (car x) 1e-6) (equal (cadar lil) (cadr x) 1e-6)) x)) tlll)))
            (progn
              (setq d1 (distance (caar lil) (inters (caar lil) (polar (caar lil) (+ (* 0.5 pi) (angle (caar ttt) (cadar ttt))) 1.0) (caar ttt) (cadar ttt) nil)))
              (setq d2 (distance (caar lil) (inters (caar lil) (polar (caar lil) (+ (* 0.5 pi) (angle (caadr ttt) (cadadr ttt))) 1.0) (caadr ttt) (cadadr ttt) nil)))
              (if
                (and
                  (not (chkcircinside-dist (caar lil) d1))
                  (not (chkcircinside-dist (caar lil) d2))
                )
                (setq lil (cddr lil))
              )
            )
          )
        )
        (if (= (length lil) (+ n 2))
          (progn
            (setq lwnl (_offset ent (- (caddr ipd))))
            (setq lwwnl (_offset ent (- (+ (caddr ipd) 1e-2))))
            (setq lwwwnl (_offset ent (- (- (caddr ipd) 1e-2))))
            (setq r nil)
            (if (setq r (mc (car ipd) (car lwnl) (car lwwnl) (car lwwwnl)))
              (progn
                (cond
                  ( (and (vl-position (caadr ipd) vll) (vl-position (cadadr ipd) vll))
                    (setq m (min (vl-position (caadr ipd) vll) (vl-position (cadadr ipd) vll)))
                  )
                  ( (vl-position (caadr ipd) vll)
                    (setq m (vl-position (caadr ipd) vll))
                  )
                  ( (vl-position (cadadr ipd) vll)
                    (setq m (vl-position (cadadr ipd) vll))
                  )
                )
                (if m
                  (progn
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vll))) (setq o (1- o))) (= m o)) (reverse vll))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vll))
                    (setq vll (append pre (list (car r)) suf))
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vlli))) (setq o (1- o))) (= m o)) (reverse vlli))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vlli))
                    (setq vlli (append pre (list (cadr r)) suf))
                  )
                  (progn
                    (foreach p vll
                      (setq ddl (cons (distance p (car r)) ddl))
                    )
                    (setq ddm (apply 'min ddl))
                    (setq m (vl-position ddm ddl))
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vll))) (setq o (1- o))) (= m o)) (reverse vll))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vll))
                    (setq vll (append pre (list (car r)) suf))
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vlli))) (setq o (1- o))) (= m o)) (reverse vlli))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vlli))
                    (setq vlli (append pre (list (cadr r)) suf))                      
                  )
                )
              )
            )
            (foreach lw lwnl
              (if (and lw (not (vlax-erased-p lw)))
                (entdel lw)
              )
            )
            (foreach lww lwwnl
              (if (and lww (not (vlax-erased-p lww)))
                (entdel lww)
              )
            )
            (foreach lwww lwwwnl
              (if (and lwww (not (vlax-erased-p lwww)))
                (entdel lwww)
              )
            )
          )
        )
        (if (= (length (vl-remove-if-not '(lambda ( x ) (equal (car ipd) (car x) 1e-6)) lil)) 3)
          (progn
            (setq vll (vl-remove-if '(lambda ( x ) (equal (car r) x 1e-6)) vll))
            (setq vlli (vl-remove-if '(lambda ( x ) (equal (cadr r) x 1.0)) vlli))
          )
        )
        (setq vll (vl-remove-if '(lambda ( x ) (equal x (caadr ipd) 1e-6)) vll))
        (setq vll (vl-remove-if '(lambda ( x ) (equal x (cadadr ipd) 1e-6)) vll))
        (setq vlli (vl-remove-if '(lambda ( x ) (equal x (caadr ipd) 1.0)) vlli))
        (setq vlli (vl-remove-if '(lambda ( x ) (equal x (cadadr ipd) 1.0)) vlli))
        (setq vll (unique vll))
        (setq vlli (unique vlli))
      )
    )
    m
  )

  (defun subprocess ( iplst / iplstoffd ipd ipdl off m ) ;;; lst - lexical global variable
    (if (setq iplst (vl-remove-if '(lambda ( x ) (or (not (car x)) (not (cadr x)))) iplst))
      (progn
        (setq iplstoffd
          (mapcar
           '(lambda ( x )
              (if (and (car x) (cadr x))
                (list
                  (mapcar '+ '(0.0 0.0) (car x))
                  (mapcar '(lambda ( y ) (mapcar '+ '(0.0 0.0) y)) (cadr x))
                  (if (setq off (offd (mapcar '+ '(0.0 0.0) (car x)) (unioncollinearplaneprints tlll)))
                    off
                  )
                )
                (list nil nil nil)
              )
            ) iplst
          )
        )
        (setq iplstoffd (vl-remove-if '(lambda ( x ) (not (caddr x))) iplstoffd))
        (foreach ipd iplstoffd
          (if (not (vl-some '(lambda ( x ) (equal x ipd 1e-6)) lst))
            (if lst
              (setq ipdl (cons (list ipd (distance (car ipd) (caar lst))) ipdl))
              (setq ipdl (cons (list ipd) ipdl))
            )
          )
        )
        (if (not lil)
          (progn
            (setq ipd (caar ipdl))
            (setq lst (cons ipd lst))
            (setq m (subbody ipd))
          )
          (progn
            (setq n (length lil))
            (setq ipdl (vl-sort ipdl '(lambda ( a b ) (< (distance (caar lst) (caar a)) (distance (caar lst) (caar b))))))
            (setq ipd (caar ipdl))
            (setq lst (cons ipd lst))
            (setq m (subbody ipd))
          )
        )
      )
    )
    m
  )

  (defun preprocess ( m / iplst kj )
    (if m
      (repeat m
        (setq vll (append (cdr vll) (list (car vll))))
        (setq vlli (append (cdr vlli) (list (car vlli))))
      )
    )
    (repeat (1- (length vll))
      (setq kj (if (not kj) 0 (1+ kj)))
      (setq iplst
        (append
          iplst
          (mapcar '(lambda ( p1 p2 p3 p4 / ip )
            (if
              (and
                p1 p2 p3 p4
                (setq ip (inters p1 p2 p3 p4 nil))
                (not (equal ip p1 1e-6)) (not (equal ip p2 1e-6)) (not (equal ip p3 1e-6)) (not (equal ip p4 1e-6))
                (inside-p ip ent enti)
                (or (equal (unit (mapcar '- ip p1)) (unit (mapcar '- p2 p1)) 0.1) (equal (unit (mapcar '- ip p1)) (unit (mapcar '- p1 p2)) 0.1))
                (or (equal (unit (mapcar '- ip p3)) (unit (mapcar '- p4 p3)) 0.1) (equal (unit (mapcar '- ip p3)) (unit (mapcar '- p3 p4)) 0.1))
                (inside-p (mapcar '+ p1 (mapcar '* (unit (mapcar '- ip p1)) (list 0.1 0.1))) ent enti)
                (inside-p (mapcar '+ p3 (mapcar '* (unit (mapcar '- ip p3)) (list 0.1 0.1))) ent enti)
              )
              (list ip (list p1 p3))
              (list nil nil)
            ))
            (mapcar '(lambda ( x ) (nth kj vll)) (cdr vll))
            (mapcar '(lambda ( x ) (nth kj vlli)) (cdr vlli))
            (vl-remove-if '(lambda ( x ) (equal x (nth kj vll) 1e-6)) vll)
            (vl-remove-if '(lambda ( x ) (equal x (nth kj vlli) 1e-6)) vlli)
          )
        )
      )
    )
    iplst
  )

  (defun prout ( / iplst )
    (setq iplst (preprocess m))
    (setq m (subprocess iplst))
  )

  (defun process ( / k )
    (setq k 0)
    (while (< (setq k (1+ k)) 50)
      (prout)
    )
  )

  (or cad (progn (vl-load-com) (setq cad (vlax-get-acad-object))))
  (or doc (setq doc (vla-get-activedocument cad)))
  (or spc (setq spc (vla-get-block (setq lay (vla-get-activelayout doc)))))

  (setq osm (getvar 'osmode))
  (setvar 'osmode 0)
  (setq cmd (getvar 'cmdecho))
  (setvar 'cmdecho 0)
  (if (= 8 (logand 8 (getvar 'undoctl)))
    (vla-endundomark doc)
  )
  (vla-startundomark doc)
  (if
    (and
      (princ "\nPick boundary closed polygonal LWPOLYLINE with only straight segments...")
      (setq s (ssget "_+.:E:S" '((0 . "LWPOLYLINE") (-4 . "&") (70 . 1) (-4 . "<not") (-4 . "<>") (42 . 0.0) (-4 . "not>"))))
      (setq lw (ssname s 0))
      (setq ti (car (_vl-times)))
      (= (cdr (assoc 0 (setq lwx (entget lw)))) "LWPOLYLINE")
      (= 1 (logand 1 (cdr (assoc 70 lwx))))
      (vl-every '(lambda ( x ) (= 0.0 (cdr x))) (vl-remove-if '(lambda ( x ) (/= (car x) 42)) lwx))
      (setq el (entlast) ent lw)
    )
    (progn
      (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -0.01))))
      (if (> (vlax-curve-getarea lwi) (vlax-curve-getarea lw))
        (setq lw (rlw lw)) ;;; force main lwpolyline CCW - counter clockwise ;;;
      )
      (setq enti (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object ent) 'offset -0.01))))
      (if (and lwi (not (vlax-erased-p lwi)))
        (entdel lwi)
      )
      (if (not f) ;;; lil, vll, vlli, tll, ppp, lst - lexical global variables ;;;
        (progn
          (if (not vlll)
            (setq vlll (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget ent))))
          )
          (if (not vllli)
            (setq vllli (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget enti))))
          )
          (if (not tlll)
            (setq tlll (mapcar '(lambda ( a b ) (list a b)) vlll (append (cdr vlll) (list (car vlll)))))
          )
          (setq lil nil vll nil vlli nil tll nil ppp nil lst nil)
          (setq f t)
        )
      )
      (setq vl vlll)
      (if (not vll)
        (setq vll vl)
      )
      (setq vli vllli)
      (if (not vlli)
        (setq vlli vli)
      )
      (setq tl tlll)
      (if (not tll)
        (setq tll tl)
      )
      (vl-cmdf "_.ZOOM" "_OB" ent "")
      (process) ;;; start and finish ...
      (vl-cmdf "_.ZOOM" "_P")
      (prompt "\nElapsed time : ") (princ (rtos (- (car (_vl-times)) ti) 2 20)) (prompt " milliseconds...")
    )
  )
  (*error* nil)
)